searchData={"content_type":"text/plain","items":[{"doc":null,"ref":"elvis.html","title":"elvis","type":"module"},{"doc":null,"ref":"elvis.html#main/1","title":"elvis.main/1","type":"function"},{"doc":"Used when starting the application on the shell.","ref":"elvis.html#start/0","title":"elvis.start/0","type":"function"},{"doc":null,"ref":"elvis.html#t:option/0","title":"elvis.option/0","type":"type"},{"doc":null,"ref":"elvis_git.html","title":"elvis_git","type":"module"},{"doc":null,"ref":"elvis_git.html#branch_files/1","title":"elvis_git.branch_files/1","type":"function"},{"doc":"Install a pre commit hook for the git repository in the current dir.","ref":"elvis_git.html#install_hook/0","title":"elvis_git.install_hook/0","type":"function"},{"doc":"Takes a git patch and an absolute file line number and returns a relative position for that line in the patch.","ref":"elvis_git.html#relative_position/2","title":"elvis_git.relative_position/2","type":"function"},{"doc":null,"ref":"elvis_git.html#run_branch/2","title":"elvis_git.run_branch/2","type":"function"},{"doc":null,"ref":"elvis_git.html#run_hook/1","title":"elvis_git.run_hook/1","type":"function"},{"doc":null,"ref":"elvis_git.html#staged_files/0","title":"elvis_git.staged_files/0","type":"function"},{"doc":null,"ref":"elvis_webhook.html","title":"elvis_webhook","type":"module"},{"doc":null,"ref":"elvis_webhook.html#event/1","title":"elvis_webhook.event/1","type":"function"},{"doc":null,"ref":"elvis_webhook.html#event/2","title":"elvis_webhook.event/2","type":"function"},{"doc":null,"ref":"elvis_webhook.html#handle_error/3","title":"elvis_webhook.handle_error/3","type":"function"},{"doc":null,"ref":"elvis_webhook.html#handle_pull_request/3","title":"elvis_webhook.handle_pull_request/3","type":"function"},{"doc":"# `elvis` [![CI][build-badge]][elvis]\n\n[elvis]: https://github.com/inaka/elvis\n[build-badge]: https://github.com/inaka/elvis/workflows/build/badge.svg\n\n![Elvis Presley dancing](https://www.reactiongifs.com/wp-content/uploads/2013/01/elvis-dance.gif)\n\n`elvis`, the Erlang style reviewer, is the command-line interface for\n[`elvis_core`](https://github.com/inaka/elvis_core).","ref":"readme.html","title":"elvis","type":"extras"},{"doc":"`elvis` is an Erlang generic style reviewer that focuses on code and configuration consistency,\nas well as readability, across your whole code base. By the very nature of the rules applied from\n`elvis_core` it can also be considered a learning tool, by trying to generalize good practices and\nallowing teams to adapt it to their own specific needs, while fostering discussions around code\nconventions.","ref":"readme.html#what-is-elvis","title":"What is `elvis`? - elvis","type":"extras"},{"doc":"Some of the advantages of using `elvis` are:\n\n* enabling consistency in style across all your code base\n* encouraging the development team to sit down and talk about code conventions\n* allowing continuous monitoring of code quality\n* helping developers avoid repeated mistakes that can be automatically detected\n* providing homogenisation among different projects in a company, therefore facilitating project\nswitching for developers, as well as allowing easier code sharing between projects\n* learning, since some of the conventions it proposes are themselves the distilled result of\nworking in very large code bases","ref":"readme.html#advantages-of-using-it","title":"Advantages of using it - elvis","type":"extras"},{"doc":"To use `elvis` as a standalone tool, you need to:\n\n```console\ngit clone https://github.com/inaka/elvis\ncd elvis\nrebar3 escriptize\nexport PATH=${PWD}/_build/default/bin:${PATH}\n```\n\n(to make the env. variable export more permanent add it to your shell's configuration file,\ni.e. `.bashrc`, `.zshrc`, ...)\n\nNow run it by calling `elvis` (or `elvis help`), and you should get to the `Usage: elvis`\ninstructions.","ref":"readme.html#installation","title":"Installation - elvis","type":"extras"},{"doc":"The most common use case is to `cd` into a folder containing an `elvis.config` file\nand executing `elvis rock`.\n\nIf you just execute `elvis` with no arguments or options you'll get to the usage instructions\noutlined in this README.","ref":"readme.html#usage","title":"Usage - elvis","type":"extras"},{"doc":"While you can get a more complete list of options by executing `elvis help`, we try to keep them\ndocumented below.\n\n### `--code-path  ` (`-p  `)\n\nAdds ` ` to the analysis' code path.\n\n### `--commands`\n\nOutputs the list of commands under stood by `elvis`.\n\n#### `git-branch  `\n\nExecutes `elvis` on source files that have changed since ` ` or ` `.\n\n#### `git-hook`\n\nExecutes `elvis` (with the specific configuration file) on the pre-commit hook Git-staged files.\n\n#### `install git-hook`\n\nInstalls `elvis` in your current Git repository, as a pre-commit hook.\n\n#### `rock [file...]`\n\nExecutes `elvis` analysis on identified files. It will, by default, consider all the files\nin the configuration (i.e. either `elvis.config` or the path set by option `--config`).\n\n### `--config  ` (`-c  `)\n\nAllows providing the path to the config. file (by default `elvis.config` is assumed).\n\n### `--help` (`-h`)\n\nShows help information.\n\n### `--keep-rocking` (`-k`)\n\nDoesn't stop analysis when erroring out on a file, if given a list of files to analyse.\n\n### `--output-format  `\n\nAllows controlling the output format of the analysis' results.\n\nThe default value is `colors`.\n\n`plain` will output results without colors.\n`parsable` will allow for consumption by systems (it's less readable for humans).\n\n### `--parallel  ` (`-P  `)\n\nAllows analyzing files concurrently.\n\nUse `n` to set the desired number of parallel workers, or `auto` to have the application choose\nan appropriate value (based on the number of schedulers).\n\n### `--quiet` (`-q`)\n\nAllows suppressing all output. The exit code will still be non-`0` if there are failing rules.\n\n### `--verbose` (`-V`)\n\nAllows verbose output.\n\n### `--version` (`-v`)\n\nOutputs the application's version.","ref":"readme.html#options","title":"Options - elvis","type":"extras"},{"doc":"`elvis` is configured via `elvis_core`'s `elvis.config` as detailed under\n[`elvis_core / Configuration`](https://github.com/inaka/elvis_core?tab=readme-ov-file#configuration).","ref":"readme.html#configuration","title":"Configuration - elvis","type":"extras"},{"doc":"A reference of all rules implemented in `elvis` can be found in `elvis_core`'s [RULES.md](https://github.com/inaka/elvis_core/blob/main/RULES.md).","ref":"readme.html#rules","title":"Rules - elvis","type":"extras"},{"doc":"If you have implemented `elvis` rule that are in your local repository or in one of\nyour dependencies, you can add these rule to your `elvis.config` file and\ntell `elvis` where to find the `.beam` that contains the compiled rule using\nthe `--code-path` option.\n\nFor example, if the rule is in one of your dependencies, you can run `elvis rock -p deps/elvis_rules/ebin -c elvis.config`.","ref":"readme.html#user-defined-rules","title":"User-defined rules - elvis","type":"extras"},{"doc":"`elvis` can be used as a [`git` pre-commit hook](https://git-scm.com/book/en/Customizing-Git-Git-Hooks#Client-Side-Hooks)\nusing the `git-hook` command (installable via `install git-hook`) as:\n\n```sh\n#!/bin/sh\nelvis git-hook\n```\n\nThis will have `elvis` execute on staged files, as per its configuration.\n\nIf any rule fails, `elvis` exits with a non-zero code, which signals to `git` that the commit\nshouldn't be made.\n\n**Note**: your pre-commit hook script should be executable (i.e. by running\n`chmod +x .git/hooks/pre-commit`), otherwise `git` won't be able to execute it.","ref":"readme.html#as-a-git-hook","title":"As a Git hook - elvis","type":"extras"},{"doc":"`elvis` can be used as a GitHub [webhook](https://developer.github.com/v3/repos/hooks/) for\n`pull request` (PR) events, by calling the `elvis_webhook:event/1` function. This will add\na comment in each file and rule that is broken, analyzing only the files associated with the PR.\n\nSince GitHub's API needs a valid username and password to allow the creation of\nreviews on PRs, parameters `github_user` and `github_password` need to be\nadded to `elvis`'s configuration file (mind you that the credentials used\nmust be from an admin. of the repo or someone with permissions for requesting changes\nto PRs).\n\nThe `elvis_webhook:event/1` function takes a map containing the keys `headers` and `body`,\nwhose values should be the map of headers and the body from the GitHub's event\nrequest.\n\n```erlang\nHeaders = #{<<\"X-GitHub-Event\">>, <<\"pull_request\">>},\nBody = <<\"{}\">>, %% JSON data from GitHub's event.\nRequest = #{headers => Headers, body => Body},\nelvis:webhook(Request).\n```\n\nThe extension to the configuration is as follows:\n\n```erlang\n[\n  {elvis, [\n    {config, [...]},\n    %% webhook configuration parameters\n    {github_user, \"user\"},\n    {github_password, \"password\"}\n  ]}\n].\n```","ref":"readme.html#as-a-webhook","title":"As a webhook - elvis","type":"extras"},{"doc":"You can generate local documentation with `rebar3 ex_doc` and then access it with `open doc/index.html`.","ref":"readme.html#documentation","title":"Documentation - elvis","type":"extras"},{"doc":"`elvis` is a FOSS application, and as such contributions are welcome. Be sure to read\nthe [contributing guide](CONTRIBUTING.md) for more detailed information.","ref":"readme.html#contributing","title":"Contributing - elvis","type":"extras"},{"doc":"`elvis` is licensed under the [Apache License, Version 2.0](LICENSE).","ref":"readme.html#license","title":"License - elvis","type":"extras"},{"doc":"`elvis` got some of its inspiration from [HoundCI](https://houndci.com/).","ref":"readme.html#inspiration","title":"Inspiration - elvis","type":"extras"},{"doc":"Apache License\n                           Version 2.0, January 2004\n                        https://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"{}\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright 2015 Erlang Solutions Ltd.\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       https://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,50,46,50]}}